package com.yizhi.live.application.vo;


import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.util.StringUtils;

import java.util.Date;


public class PageLiveVo {

    @ApiModelProperty(value = "主键")
    private Long id;

    @ApiModelProperty(value = "直播主题")
    private String title;

    @ApiModelProperty(value = "直播密码")
    private String password;

    @ApiModelProperty(value = "直播logo")
    private String logoImage;

    @ApiModelProperty(value = "主播名称")
    private String anchor;

    @ApiModelProperty(value = "开始时间")
    private Date startTime;

    @ApiModelProperty(value = "结束时间")
    private Date endTime;

    @ApiModelProperty(value = "直播状态 ")
    private String status;

    @ApiModelProperty(value = "频道号")
    private String channel;

    @ApiModelProperty(value = "0 未上架 1 已上架")
    private Integer shelves;
    
    
    @ApiModelProperty(value = "可见范围 0全平台  1指定用户")
    private Integer scope;

    @ApiModelProperty(value = "直播介绍")
    private String description;

    @ApiModelProperty(value = "0 公开直播。1：站内直播")
    private Integer viewType;

    @ApiModelProperty(value = "直播在学人数")
    private Integer onlineCount;

    private Integer liveStatus;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getLogoImage() {
        return logoImage;
    }

    public void setLogoImage(String logoImage) {
        this.logoImage = logoImage;
    }

    public String getAnchor() {
        return anchor;
    }

    public void setAnchor(String anchor) {
        this.anchor = anchor;
    }

    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getChannel() {
        return channel;
    }

    public void setChannel(String channel) {
        this.channel = channel;
    }

    public Integer getShelves() {
        return shelves;
    }

    public void setShelves(Integer shelves) {
        this.shelves = shelves;
    }

    public Integer getScope() {
        return scope;
    }

    public void setScope(Integer scope) {
        this.scope = scope;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getViewType() {
        return viewType;
    }

    public void setViewType(Integer viewType) {
        this.viewType = viewType;
    }

    public Integer getOnlineCount() {
        return onlineCount;
    }

    public void setOnlineCount(Integer onlineCount) {
        this.onlineCount = onlineCount;
    }

    public Integer getLiveStatus() {
        if (StringUtils.isEmpty(this.status)){
            return 10;
        }else {
            return Integer.valueOf(this.status);
        }
    }

    public void setLiveStatus(Integer liveStatus) {
        this.liveStatus = liveStatus;
    }
}
