package com.yizhi.live.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.live.application.domain.ScopeAuthorization;
import com.yizhi.live.application.vo.ScopeAuthorizationVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Set;

/**
 * <p>
 * 直播授权课件范围表 Mapper 接口
 * </p>
 *
 * @author fulan123
 * @since 2018-04-10
 */
public interface ScopeAuthorizationMapper extends BaseMapper<ScopeAuthorization> {

    List<Long> selectLiveIdByRelationId(@Param("relationIds") List<Long> relationIds);


    Boolean insertListVO(@Param("list")List<ScopeAuthorizationVO> list);

    Boolean insertList(@Param("list")List<ScopeAuthorization> list);

    Set<Long> selectLiveId(@Param("relationIds") List<Long> relationIds, @Param("siteId") Long siteId);


    List<Long> getUsefulIds(@Param("ids") List<Long> ids,
                            @Param("relationIds") List<Long> relationIds,
                            @Param("siteId") Long siteId);

    /**
     * 删除可见范围
     * @param liveId
     */
    void deleteAuthorize(@Param("liveId") Long liveId);

    /**
     * 查询直播回放开启的直播间id集合
     * @param authLiveIds 指定用户可见的直播id
     * @return
     */
    List<Long> selectReplayOnLiveIds(@RequestParam("authLiveIds") List<Long> authLiveIds,@RequestParam("companyId") Long companyId,@RequestParam("siteId") Long siteId);
}
